'use strict';

var parseStatic = require('./parseStatic');
var createStyleComponent = require('./createStyleComponent');
var createCompositeComponent = require('./createCompositeComponent');

module.exports = function () {
  var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var library = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  if (config.imports) {
    return createCompositeComponent(config, library);
  }

  if (!config.name || !config.type || !config.style) return null;

  var parsed = parseStatic(config);
  var tag = library[parsed.type] || parsed.type;
  var Component = createStyleComponent(tag)(parsed, options);

  return Component;
};